# xDevs.com Python CSV parser
#  (i) Tsemenko Illya
#  (i) 2008-2015
import csv
from datetime import datetime
import glob
import os
from os import walk

print ("%s" % glob.glob("tcr_kxr" + "*.csv"))
filecnt = len([name for name in os.listdir('.') if os.path.isfile(name) & name.endswith('csv') & name.startswith('tcr_kxr')])
print ("Total %d CSV files here\r\n" % filecnt)

for fcnt in range (0, filecnt):
    fi = open(glob.glob("tcr_kxr" + "*.csv")[fcnt], 'rb')
    data = fi.read()
    fi.close()
    fname = glob.glob("tcr_kxr*.csv")[fcnt]
    nname = fname.replace(".csv", "") + "_clean.dsv"
    #print ("%s\n" % nname)
    fo = open(nname, 'wb')
    fo.write(data.replace('\x00', ''))
    fo.close()

filednt = len([name for name in os.listdir('.') if os.path.isfile(name) & name.endswith('dsv') & name.startswith('tcr_kxr')])
print ("Total %d clean DSV files here\r\n" % filednt)

# Open CSV file with input data (in this case - input.csv)
for dcnt in range (0, filednt):
    with open(glob.glob("tcr_kxr" + "*.dsv")[dcnt],'rb') as i:
        print i
        # Create new file, which will have parsed output
        di = glob.glob("tcr_kxr" + "*.dsv")[dcnt]
        nname = di.replace(".dsv", "") + "_reduced.psv"
        with open(nname,'wb') as o:
            # Read data from test2.csv file
            r = csv.DictReader(i,delimiter=';')
            o.write ("date;hp3458a;temp;ext_temp;rh;pressure;tec_rtd;res_rtd;dcorr;\r\n")
            # Create row counter variable, and null it.
            rowcount = 1
            corr = 0.0
            for pos,row in enumerate(r, 1):
                if pos % 1 == 0:
                    # Every new line will increment counter/index
                    #                                   11/12/2015-09:11:11
                    try:
                        d = datetime.strptime(row['date'], '%d/%m/%Y-%H:%M:%S')
                        date = d.strftime('%d/%m/%Y-%H:%M:%S')
                    except ValueError:
                        print ("-------- Error in line %d ------------" % rowcount)
                        #continue #If you are 
                    #d = datetime.strptime(row['date'], '%d/%m/%Y-%H:%M:%S')
                    #date = d.strftime('%Y/%m/%d %H:%M:%S')
                    rowcount +=1
                    corr = 1 + ((float(row['temp']) - 35.0) * -366E-9)
                    dcorr = float(row['hp3458a']) * corr
                    if (rowcount % 16 == 0):
                	print  ('%s;%2.8f;%s;%s;%s;%s; correction %8.8E, corrected : %2.8f' % (date,float(row['hp3458a']),row['temp'],row['ext_temp'],row['rh'],row['pressure'],corr,dcorr)) #Output to screen
#                    o.write ('%s;%2.8f;%s;%s;%s;%s;%s;%s;\r\n' % (date,float(row['hp3458a']),row['temp'],row['ext_temp'],row['rh'],row['pressure'],row['tec_rtd'],row['res_rtd'])) #Output to screen
                    o.write ('%s;%2.8f;%s;%s;%s;%s;%s;%s;%2.8f;\r\n' % (date,float(row['hp3458a']),row['temp'],row['ext_temp'],row['rh'],row['pressure'],row['tec_rtd'],row['res_rtd'],dcorr)) #Output to screen